// Name: UnGUT.C
// Desc: 'Shadow Company' GUT files unpacker
// Vers: V 1.3, 4/03/2002
// Targ: Win32 console application
// Comp: MS Visual C++ 6.0
// Copy: (c) by slim <sgusev@mail.ru>
// Comm: 'cl /O1 /Zp2 /Oi ungut.c /link /noentry /opt:nowin98 kernel32.lib'

#include <stdio.h>
#include <direct.h>

#pragma pack(1)

enum { OP_LIST, OP_EXT };

typedef struct {
	unsigned int iX1;
	unsigned int iX2;
	unsigned int iFiles;
	char sName[32];
} THdr;

typedef struct {
	unsigned int iNameLength;
	unsigned int iSize;
	unsigned int iPos;
	unsigned int iFlags;		// If = 1 then content is 'not'-ed...
	unsigned int iX;
} TFHdr;

FILE *fi;

int operation;

void usage(char *fileName)
{
  char *progName = strrchr( fileName, '\\');
  if( !progName)
    progName = fileName;
  else
    progName++;

  printf( "Usage: %s <operation> <GUTFileName>\n"
  	  "\nWhere operation is:\n\n"
          "\tl - List GUT file\n"
          "\te - Extract files from GUT file\n"
          , progName);
}

void savefile(TFHdr * _dFHdr, char * sFName)
{
	char sBuf[1024],* sCur=sFName;
	FILE *fo;
	unsigned int iBlocks,iEnd,i,j;

	sCur=(char *)strchr(sCur,0x5C);
	while (sCur!=NULL)
	{
		strncpy((char *)&sBuf,sFName,(unsigned int)(sCur-sFName));
		sBuf[(unsigned int)(sCur-sFName)]=0;
		mkdir((char *)&sBuf);
		sCur=(char *)strchr(&sCur[1],0x5C);
	}

	iBlocks=_dFHdr->iSize>>10;
	iEnd=_dFHdr->iSize&0x3FF;
	fseek(fi,_dFHdr->iPos,SEEK_SET);
	fo=fopen(sFName,"wb");

	for (i=0; i<iBlocks; i++)
	{
		fread(&sBuf,1,1024,fi);
		if (_dFHdr->iFlags>0) for (j=0; j<1024; j++) (unsigned char)sBuf[j]^=0xFF;
		fwrite(&sBuf,1,1024,fo);
	}

	if (iEnd>0)
	{
		fread(&sBuf,1,iEnd,fi);
		if (_dFHdr->iFlags>0) for (j=0; j<iEnd; j++) (unsigned char)sBuf[j]^=0xFF;
		fwrite(&sBuf,1,iEnd,fo);
	}

	fclose(fo);
}

void main(int argc, char *argv[])
{
	unsigned char sBuf[512];
	unsigned int i,j,iFSize,iDelta,iOldPos;
	THdr dHdr;
	TFHdr dFHdr;
	char FullName[256];

	printf("\n'Shadow Company' GUT Files Unpacker.\t(c) by slim <sgusev@mail.ru>\n");
	
	if (argc<3)
	{
		usage(argv[0]);		
		return;
	}

	switch( tolower(argv[ 1][ 0]))
	{
		case 'e':
   			operation = OP_EXT;
        	break;
		case 'l':
   			operation = OP_LIST;
       	break;
	default:
   		usage(argv[ 0]);
      	return;
	}


	if ((fi=fopen(argv[2],"rb"))==NULL)
	{
		printf("Can't open GUT file '%s'...\n",argv[2]);
		return;
	}

	fseek(fi,0,SEEK_END);
	iFSize=ftell(fi);
	if (iFSize<512)
	{
		fclose(fi);
		printf("File '%s' is not correct GUT file...\n",argv[2]);
		return;
	}
	fseek(fi,0,SEEK_SET);
	fread(&sBuf,1,512,fi);

	for (i=0; i<512; i++) if (sBuf[i]==0x1A) break;
	if (i>=512)
	{
		fclose(fi);
		printf("File '%s' is not correct GUT file...\n",argv[2]);
		return;
	}

	fseek(fi,i,SEEK_SET);
	fread(&dHdr,1,sizeof(THdr),fi);
	iDelta=ftell(fi);

	printf("\nFind %i files in '%s' file.\n",dHdr.iFiles,argv[2]);

	if( operation == OP_LIST)
  	{
     		memset(FullName, '-', 75);
     		FullName[75] = '\x0';
     		printf("\n%-57s %8s %8s\n%s\n", "name", "size", "offset", FullName);
  	}

	for (i=0; i<dHdr.iFiles; i++)
	{
		fread(&dFHdr,1,sizeof(TFHdr),fi);
		dFHdr.iPos+=iDelta;
		fread(&sBuf,1,dFHdr.iNameLength,fi);
		for (j=0; j<dFHdr.iNameLength; j++) sBuf[j]^=0xFF;
		iOldPos=ftell(fi);

		if (operation == OP_EXT)
		{	
			printf("Extracting file: %s\n",&sBuf);
			savefile(&dFHdr,(char *)&sBuf);
		}

		if (operation == OP_LIST)
		{
			printf( "%-57s %8d %08X\n", &sBuf, dFHdr.iSize, dFHdr.iPos);
		}

		fseek(fi,iOldPos,SEEK_SET);
	}
	fclose(fi);

	if (operation == OP_EXT)
	{	
		printf("\nMoving the GUT file '%s' into another directory!\n",argv[2]);
	}
}
